#include "potions.h"

#include "constants.h"
#include "potions/restore_health.h"
#include "potions/boost_atk.h"
#include "potions/boost_def.h"
#include "potions/poison_health.h"
#include "potions/wound_atk.h"
#include "potions/wound_def.h"
#include "potions/continuous_restoration.h"
#include "potions/savage_strike.h"
#include "potions/echoing_resilience.h"
#include "potions/tempest_tantrum.h"
#include "potions/bezerk_brew.h"
#include "potions/borrow_life.h"
#include "potions/fine_booze.h"
#include "potions/ironclad_ward.h"

std::unique_ptr<potion> new_potion(potion_type type, const position &pos) {
        switch (type) {
        case restore_health:
                return std::make_unique<class restore_health>(pos);

        case boost_atk:
                return std::make_unique<class boost_atk>(pos);

        case boost_def:
                return std::make_unique<class boost_def>(pos);

        case poison_health:
                return std::make_unique<class poison_health>(pos);

        case wound_atk:
                return std::make_unique<class wound_atk>(pos);

        case wound_def:
                return std::make_unique<class wound_def>(pos);

        case continuous_restoration:
                return std::make_unique<class continuous_restoration>(pos);

        case savage_strike:
                return std::make_unique<class savage_strike>(pos);

        case echoing_resilience:
                return std::make_unique<class echoing_resilience>(pos);

        case tempest_tantrum:
                return std::make_unique<class tempest_tantrum>(pos);

        case bezerk_brew:
                return std::make_unique<class bezerk_brew>(pos);

        case borrow_life:
                return std::make_unique<class borrow_life>(pos);

        case fine_booze:
                return std::make_unique<class fine_booze>(pos);

        case ironclad_ward:
                return std::make_unique<class ironclad_ward>(pos);

        default:
                break;
        }

        return nullptr;
}
